Attribute VB_Name = "modRAEdit"
Option Explicit

'Message constants
Private Const REM_SETHILITEWORDS = &H400 + 1000 + 0   'wParam=0, lParam=lpRAFONT
Private Const REM_SETFONT = &H400 + 1000 + 1          'wParam=nColor, lParam=lpszWords
Private Const REM_SETCOLOR = &H400 + 1000 + 3         'wParam=0, lParam=lpRACOLOR
Private Const REM_GETCOLOR = &H400 + 1000 + 4         'wParam=0, lParam=lpRACOLOR
Private Const WM_SETTEXT = &HC
Private Const WM_CUT = &H300
Private Const WM_COPY = &H301
Private Const WM_PASTE = &H302
Private Const WM_CLEAR = &H303

Private Const EM_STREAMIN = &H400 + 73
Private Const EM_STREAMOUT = &H400 + 74
Private Const EM_SETMODIFY = &HB9
Private Const EM_GETMODIFY = &HB8
Private Const EM_LINEINDEX = &HBB
Private Const EM_EXSETSEL = &H400 + 55
Private Const EM_SCROLLCARET = &HB7
Private Const EM_UNDO = &HC7
Private Const EM_REDO = &H400 + 84

'Words to hilite
Private Const szRegs As String = "AH AL AX BH BL BP BX CH CL CR0 CR2 CR3 CS CX DH DI DL DR0 DR1 DR2 DR3 DR6 DR7 DS DX EAX EBP EBX ECX EDI EDX ES ESI ESP FS GS MM0 MM1 MM2 MM3 MM4 MM5 MM6 MM7 SI SP SS ST TR3 TR4 TR5 TR6 TR7 XMM0 XMM1 XMM2 XMM3"
Private Const szInst As String = "AAA AAD AAM AAS ADC ADD AND CALL CBW CLC CLD CLI CMC CMP CMPS CMPSB CMPSW CWD DAS DEC DIV DAA ESC HLT IDIV IMUL IN INC INT INTO IRET JA JAE JB JBE JC JCXZ JE JG JGE JL JLE JMP JNA JNAE JNB JNBE JNC JNE JNG JNGE JNL JNLE JNO JNP JNS JNZ JO JP JPE JPO JS JZ LAHF LDS LEA LES LODS LODSB LODSW LOOP LOOPE LOOPEW LOOPNE LOOPNEW LOOPNZ LOOPNZW LOOPW LOOPZ LOOPZW MOV MOVS MOVSB MOVSW MUL NEG NOP NOT OR OUT POP POPF PUSH PUSHF RCL RCR RET RETF RETN ROL ROR SAHF SAL SAR SBB SCAS SCASB SCASW SHL SHR STC STD STI STOS STOSB STOSW SUB TEST WAIT XCHG XLAT XLATB XOR"
Private Const szMasm As String = ".BREAK .CONTINUE .ELSE .ELSEIF .ENDIF .ENDW .IF .REPEAT .UNTIL .UNTILCXZ .WHILE INVOKE"

Public hREd As Long
Public szCurrentFile As String
Private raf As RAFONT
Private col As RACOLOR

'Some Api's
Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SendMessageStr Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, ByVal lpBuffer As Long, ByVal nNumberOfBytesToRead As Long, ByVal lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, ByVal lpBuffer As Long, ByVal nNumberOfBytesToWrite As Long, ByVal lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SetFocus Lib "user32" (ByVal hwnd As Long) As Long

Private Type EDITSTREAM
  dwCookie    As Long
  dwError     As Long
  pfnCallback As Long
End Type

Private Type LOGFONT
  lfHeight            As Long
  lfWidth             As Long
  lfEscapement        As Long
  lfOrientation       As Long
  lfWeight            As Long
  lfItalic            As Byte
  lfUnderline         As Byte
  lfStrikeOut         As Byte
  lfCharSet           As Byte
  lfOutPrecision      As Byte
  lfClipPrecision     As Byte
  lfQuality           As Byte
  lfPitchAndFamily    As Byte
  lfFaceName(1 To 32) As Byte
End Type

Private Type RAFONT
  hFont       As Long   'Normal font
  hIFont      As Long   'Italics font
  hLnrFont    As Long   'Line number font
End Type

Private Type RACOLOR
  bckcol      As Long   'Back color
  txtcol      As Long   'Text color
  selbckcol   As Long   'Sel back color
  seltxtcol   As Long   'Sel text color
  cmntcol     As Long   'Comment color
  strcol      As Long   'String color
  oprcol      As Long   'Operator color
  hicol1      As Long   'Line hilite 1
  hicol2      As Long   'Line hilite 2
  hicol3      As Long   'Line hilite 3
  selbarbck   As Long   'Selection bar
  selbarpen   As Long   'Selection bar pen
  lnrcol      As Long   'Line numbers color
End Type

Private Type CHARRANGE
  cpMin  As Long
  cpMax  As Long
End Type

Function LoadDLL() As Long
  LoadDLL = LoadLibrary("RAEdit.dll")
End Function

Function CreateRAEdit(hPar As Long) As Long
  CreateRAEdit = CreateWindowEx(&H200, "RAEDIT", 0, &H50010040, 0, 0, 0, 0, hPar, 0, &H400000, 0)
End Function

Function SetFonts() As Long
Dim lf As LOGFONT
Dim lRet As Long
Dim szFont As String
Dim i As Integer
  lf.lfHeight = -12
  szFont = "Courier New" & String(32, Chr(0))
  For i = 1 To 32
    lf.lfFaceName(i) = Asc(Mid(szFont, i, 1))
  Next i
  lRet = CreateFontIndirect(lf)
  raf.hFont = lRet
  lf.lfItalic = True
  lRet = CreateFontIndirect(lf)
  raf.hIFont = lRet
  lf.lfHeight = -8
  szFont = "Terminal" & String(32, Chr(0))
  For i = 1 To 32
    lf.lfFaceName(i) = Asc(Mid(szFont, i, 1))
  Next i
  lf.lfItalic = False
  lRet = CreateFontIndirect(lf)
  raf.hLnrFont = lRet
  SetFonts = SendMessage(hREd, REM_SETFONT, 0, raf)
End Function

Function KillFonts() As Long
Dim lRet As Long
  lRet = DeleteObject(raf.hFont)
  lRet = DeleteObject(raf.hIFont)
  lRet = DeleteObject(raf.hLnrFont)
End Function

Function SetHiliteWords()
Dim lRet As Long
  lRet = SendMessageStr(hREd, REM_SETHILITEWORDS, &HA00000, szRegs)
  lRet = SendMessageStr(hREd, REM_SETHILITEWORDS, &H40A000, szInst)
  lRet = SendMessageStr(hREd, REM_SETHILITEWORDS, &H4040A0, szMasm)
End Function

Function SetColors()
  'Get all default colors
  SetColors = SendMessage(hREd, REM_GETCOLOR, 0, col)
  'Change some colors
  col.oprcol = vbBlue
  SetColors = SendMessage(hREd, REM_SETCOLOR, 0, col)
End Function

Function SetFocusToRAEdit() As Long
Dim lRet As Long
  lRet = SetFocus(hREd)
End Function

Function SizeRAEdit(hwnd As Long, x As Long, y As Long, wt As Long, ht As Long) As Long
  SizeRAEdit = MoveWindow(hwnd, x, y, wt, ht, True)
End Function

Function StreamFileIn(ByVal hFile As Long, ByVal pBuffer As Long, ByVal NumBytes As Long, ByVal pBytesRead As Long) As Long
  StreamFileIn = ReadFile(hFile, pBuffer, NumBytes, pBytesRead, 0)
  StreamFileIn = StreamFileIn Xor 1
End Function

Function LoadFile(szFileName As String, lpStream As Long) As Long
Dim hFile As Long
Dim lRet As Long
Dim edts As EDITSTREAM
  lRet = SendMessage(hREd, WM_SETTEXT, 0, 0)
  hFile = CreateFile(szFileName, &H80000000, &H1, 0, &H3, &H80, 0)
  edts.dwCookie = hFile
  edts.pfnCallback = lpStream
  lRet = SendMessage(hREd, EM_STREAMIN, 1, edts)
  lRet = CloseHandle(hFile)
  lRet = SendMessage(hREd, EM_SETMODIFY, False, 0)
End Function

Function StreamFileOut(ByVal hFile As Long, ByVal pBuffer As Long, ByVal NumBytes As Long, ByVal pBytesWritten As Long) As Long
  StreamFileOut = WriteFile(hFile, pBuffer, NumBytes, pBytesWritten, 0)
  StreamFileOut = StreamFileOut Xor 1
End Function

Function SaveFile(szFileName As String, lpStream As Long) As Long
Dim hFile As Long
Dim lRet As Long
Dim edts As EDITSTREAM
  hFile = CreateFile(szFileName, &H40000000, &H1, 0, &H2, &H80, 0)
  edts.dwCookie = hFile
  edts.pfnCallback = lpStream
  lRet = SendMessage(hREd, EM_STREAMOUT, 1, edts)
  lRet = CloseHandle(hFile)
  lRet = SendMessage(hREd, EM_SETMODIFY, False, 0)
End Function

Function Undo() As Long
  Undo = SendMessage(hREd, EM_UNDO, 0, 0)
End Function

Function Redo() As Long
  Redo = SendMessage(hREd, EM_REDO, 0, 0)
End Function

Function Cut() As Long
  Cut = SendMessage(hREd, WM_CUT, 0, 0)
End Function

Function Copy() As Long
  Copy = SendMessage(hREd, WM_COPY, 0, 0)
End Function

Function Paste() As Long
  Paste = SendMessage(hREd, WM_PASTE, 0, 0)
End Function

Function Delete() As Long
  Delete = SendMessage(hREd, WM_CLEAR, 0, 0)
End Function

Function GotoLine(lLine As Long) As Long
Dim chrg As CHARRANGE
  GotoLine = SendMessage(hREd, EM_LINEINDEX, lLine, 0)
  chrg.cpMin = GotoLine
  chrg.cpMax = GotoLine
  GotoLine = SendMessage(hREd, EM_EXSETSEL, 0, chrg)
  GotoLine = SendMessage(hREd, EM_SCROLLCARET, 0, 0)
  GotoLine = SetFocusToRAEdit
End Function

Function GetModify() As Long
  GetModify = SendMessage(hREd, EM_GETMODIFY, 0, 0)
End Function
