Attribute VB_Name = "modRAGrid"
Option Explicit

'Messages
Private Const WM_SETFONT = &H30
Private Const WM_USER = &H400
Private Const GM_ADDCOL = WM_USER + 1         'wParam=0, lParam=lpCOLUMN
Private Const GM_ADDROW = WM_USER + 2         'wParam=0, lParam=lpROWDATA (can be NULL)
Private Const GM_INSROW = WM_USER + 3         'wParam=nRow, lParam=lpROWDATA (can be NULL)
Private Const GM_DELROW = WM_USER + 4         'wParam=nRow, lParam=0
Private Const GM_MOVEROW = WM_USER + 5        'wParam=nFromRow, lParam=nToRow
Private Const GM_COMBOADDSTRING = WM_USER + 6 'wParam=nCol, lParam=lpszString
Private Const GM_COMBOCLEAR = WM_USER + 7     'wParam=nCol, lParam=0
Private Const GM_GETCURSEL = WM_USER + 8      'wParam=0, lParam=0
Private Const GM_SETCURSEL = WM_USER + 9      'wParam=nCol, lParam=nRow
Private Const GM_GETCURCOL = WM_USER + 10     'wParam=0, lParam=0
Private Const GM_SETCURCOL = WM_USER + 11     'wParam=nCol, lParam=0
Private Const GM_GETCURROW = WM_USER + 12     'wParam=0, lParam=0
Private Const GM_SETCURROW = WM_USER + 13     'wParam=nRow, lParam=0
Private Const GM_GETCOLCOUNT = WM_USER + 14   'wParam=0, lParam=0
Private Const GM_GETROWCOUNT = WM_USER + 15   'wParam=0, lParam=0
Private Const GM_GETCELLDATA = WM_USER + 16   'wParam=nRowCol, lParam=lpData
Private Const GM_SETCELLDATA = WM_USER + 17   'wParam=nRowCol, lParam=lpData
Private Const GM_GETCELLRECT = WM_USER + 18   'wParam=nRowCol, lParam=lpRECT
Private Const GM_SCROLLCELL = WM_USER + 19    'wParam=0, lParam=0
Private Const GM_GETBACKCOLOR = WM_USER + 20  'wParam=0, lParam=0
Private Const GM_SETBACKCOLOR = WM_USER + 21  'wParam=nColor, lParam=0
Private Const GM_GETGRIDCOLOR = WM_USER + 22  'wParam=0, lParam=0
Private Const GM_SETGRIDCOLOR = WM_USER + 23  'wParam=nColor, lParam=0
Private Const GM_GETTEXTCOLOR = WM_USER + 24  'wParam=0, lParam=0
Private Const GM_SETTEXTCOLOR = WM_USER + 25  'wParam=nColor, lParam=0
Private Const GM_ENTEREDIT = WM_USER + 26     'wParam=nCol, lParam=nRow
Private Const GM_ENDEDIT = WM_USER + 27       'wParam=nRowCol, lParam=fCancel
Private Const GM_GETCOLWIDTH = WM_USER + 28   'wParam=nCol, lParam=0
Private Const GM_SETCOLWIDTH = WM_USER + 29   'wParam=nCol, lParam=nWidth
Private Const GM_GETHDRHEIGHT = WM_USER + 30  'wParam=0, lParam=0
Private Const GM_SETHDRHEIGHT = WM_USER + 31  'wParam=0, lParam=nHeight
Private Const GM_GETROWHEIGHT = WM_USER + 32  'wParam=0, lParam=0
Private Const GM_SETROWHEIGHT = WM_USER + 33  'wParam=0, lParam=nHeight
Private Const GM_RESETCONTENT = WM_USER + 34  'wParam=0, lParam=0
Private Const GM_COLUMNSORT = WM_USER + 35    'wParam=nCol, lParam=0=Ascending, 1=Descending, 2=Invert
Private Const GM_GETHDRTEXT = WM_USER + 36    'wParam=nCol, lParam=lpBuffer
Private Const GM_SETHDRTEXT = WM_USER + 37    'wParam=nCol, lParam=lpszText
Private Const GM_GETCOLFORMAT = WM_USER + 38  'wParam=nCol, lParam=lpBuffer
Private Const GM_SETCOLFORMAT = WM_USER + 39  'wParam=nCol, lParam=lpszText
Private Const GM_CELLCONVERT = WM_USER + 40   'wParam=nRowCol, lParam=lpBuffer
Private Const GM_RESETCOLUMNS = WM_USER + 41  'wParam=0, lParam=0

'Column alignment
Private Const ALIGN_LEFT = 0
Private Const ALIGN_CENTER = 1
Private Const ALIGN_RIGHT = 2

'Column types
Private Const TYPE_EDITTEXT = 0       'String
Private Const TYPE_EDITLONG = 1       'Long
Private Const TYPE_CHECKBOX = 2       'Long
Private Const TYPE_COMBOBOX = 3       'Long
Private Const TYPE_HOTKEY = 4         'Long
Private Const TYPE_BUTTON = 5         'String
Private Const TYPE_IMAGE = 6          'Long
Private Const TYPE_DATE = 7           'Long
Private Const TYPE_TIME = 8           'Long
Private Const TYPE_USER = 9           '0=String, 1 to 512 bytes binary data

'Window styles
Private Const STYLE_NOSEL = 1
Private Const STYLE_NOFOCUS = 2
Private Const STYLE_HGRIDLINES = 4
Private Const STYLE_VGRIDLINES = 8
Private Const STYLE_GRIDFRAME = 16


Private Type LOGFONT
  lfHeight            As Long
  lfWidth             As Long
  lfEscapement        As Long
  lfOrientation       As Long
  lfWeight            As Long
  lfItalic            As Byte
  lfUnderline         As Byte
  lfStrikeOut         As Byte
  lfCharSet           As Byte
  lfOutPrecision      As Byte
  lfClipPrecision     As Byte
  lfQuality           As Byte
  lfPitchAndFamily    As Byte
  lfFaceName(1 To 32) As Byte
End Type

'Column structure
Private Type COLUMN
  colwt       As Long      'Column width.
  lpszhdrtext As String    'Pointer to header text.
  halign      As Long      'Header text alignment.
  calign      As Long      'Column text alignment.
  ctype       As Long      'Column data type.
  ctextmax    As Long      'Max text lenght for TYPE_EDITTEXT and TYPE_EDITLONG.
  lpszformat  As String    'Format string for TYPE_EDITLONG.
  himl        As Long      'Handle of image list. For the image columns and combobox only.
  hdrflag     As Long      'Header flags.
  colxp       As Long      'Column position. Internally used.
  edthwnd     As Long      'Column control handle. Internally used.
End Type

Private Type ROWDATA
  lpszname    As String
  lpszadress  As String
End Type

'Some Api's
Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SetFocus Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Public hGrid As Long
Private hFont As Long

Function LoadDLL() As Long
  LoadDLL = LoadLibrary("RAGrid.dll")
End Function

Function SetFont() As Long
Dim lf As LOGFONT
Dim szFont As String
Dim i As Integer
  lf.lfHeight = -10
  szFont = "MS Sans Serif" & String(32, Chr(0))
  For i = 1 To 32
    lf.lfFaceName(i) = Asc(Mid(szFont, i, 1))
  Next i
  hFont = CreateFontIndirect(lf)
  SetFont = SendMessage(hGrid, WM_SETFONT, hFont, 0)
End Function

Function KillFont() As Long
  KillFont = DeleteObject(hFont)
End Function

Function CreateRAGrid(hPar As Long) As Long
  CreateRAGrid = CreateWindowEx(&H200, "RAGRID", 0, &H50010000 Or STYLE_HGRIDLINES Or STYLE_VGRIDLINES Or STYLE_NOSEL, 0, 0, 0, 0, hPar, 0, &H400000, 0)
End Function

Function SetFocusToRAGrid() As Long
Dim lRet As Long
  lRet = SetFocus(hGrid)
End Function

Function SizeRAGrid(hwnd As Long, x As Long, y As Long, wt As Long, ht As Long) As Long
  SizeRAGrid = MoveWindow(hwnd, x, y, wt, ht, True)
End Function

Function AddColumns() As Long
Dim col As COLUMN
Dim lRet As Long
  col.colwt = 200
  col.lpszhdrtext = "Name"
  col.halign = ALIGN_LEFT
  col.calign = ALIGN_LEFT
  col.ctype = TYPE_EDITTEXT
  col.ctextmax = 31
  col.lpszformat = 0
  col.himl = 0
  col.hdrflag = 0
  lRet = SendMessage(hGrid, GM_ADDCOL, 0, col)
  col.colwt = 200
  col.lpszhdrtext = "Adress"
  col.halign = ALIGN_LEFT
  col.calign = ALIGN_LEFT
  col.ctype = TYPE_EDITTEXT
  col.ctextmax = 31
  col.lpszformat = 0
  col.himl = 0
  col.hdrflag = 0
  lRet = SendMessage(hGrid, GM_ADDCOL, 0, col)
End Function

Function AddRow(szName As String, szAdress As String) As Long
Dim row As ROWDATA
  row.lpszname = szName
  row.lpszadress = szAdress
  AddRow = SendMessage(hGrid, GM_ADDROW, 0, row)
End Function
